/*
 * This file is part of JPuzzle.
 *
 * JPuzzle is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * JPuzzle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JPuzzle.  If not, see <http://www.gnu.org/licenses/>.
 *
 * JPuzzle Copyright © 2008 HackmanGT
 * HackmanGT@hotmail.com
 */

package JPuzzle.Event;

/**
 * Evento generado por un cambio en la mesa.
 * Cuando selecciona Desordenar o Resolver.
 * @author HackmanGT
 */
public class MesaActionEvent extends java.util.EventObject {

    private boolean running = false;
    private String message;

    /**
     * Construye un nuevo evento con el origen
     * y la indicación si está corriendo.
     */
    public MesaActionEvent(Object source, boolean running, String message) {
        super(source);
        this.running = running;
        this.message = message;
    }

    /**
     * Devuelve el estado de "ejecutandose".
     * @return el estado de "ejecutandose"
     */
    public boolean isRunning() {
        return running;
    }

    /**
     * Asigna un estado a "ejecutandose"
     * @param running el estado de "ejecutandose"
     */
    public void setRunning(boolean running) {
        this.running = running;
    }

    /**
     * Devuelve el mensaje.
     * @return el mensaje
     */
    public String getMessage() {
        return message;
    }

    /**
     * Asigna un valor al mensaje
     * @param message el mensaje
     */
    public void setMessage(String message) {
        this.message = message;
    }
}
